2 # Copyright (c) 2007, Nanako Shiraishi
4 dashless=$(basename "$0" | sed -e 's/-/ /')
5 USAGE="list [<options>]
6 or: $dashless show [<stash>]
7 or: $dashless drop [-q|--quiet] [<stash>]
8 or: $dashless ( pop | apply ) [--index] [-q|--quiet] [<stash>]
9 or: $dashless branch <branchname> [<stash>]
10 or: $dashless [save [--keep-index] [-q|--quiet] [<message>]]
19 TMP="$GIT_DIR/.git-stash.$$"
20 trap 'rm -f "$TMP-*"' 0
25 git diff-index --quiet --cached HEAD --ignore-submodules -- &&
26 git diff-files --quiet --ignore-submodules
32 die "git stash clear with parameters is unimplemented"
34 if current=$(git rev-parse --verify $ref_stash 2>/dev/null)
36 git update-ref -d $ref_stash $current
43 git update-index -q --refresh
49 # state of the base commit
50 if b_commit=$(git rev-parse --verify HEAD)
52 head=$(git log --no-color --abbrev-commit --pretty=oneline -n 1 HEAD --)
54 die "You do not have the initial commit yet"
57 if branch=$(git symbolic-ref -q HEAD)
59 branch=${branch#refs/heads/}
63 msg=$(printf '%s: %s' "$branch" "$head")
66 i_tree=$(git write-tree) &&
67 i_commit=$(printf 'index on %s\n' "$msg" |
68 git commit-tree $i_tree -p $b_commit) ||
69 die "Cannot save the current index state"
71 # state of the working tree
74 cp -p ${GIT_INDEX_FILE-"$GIT_DIR/index"} "$TMP-index" &&
75 GIT_INDEX_FILE="$TMP-index" &&
76 export GIT_INDEX_FILE &&
77 git read-tree -m $i_tree &&
82 die "Cannot save the current worktree state"
85 if test -z "$stash_msg"
87 stash_msg=$(printf 'WIP on %s' "$msg")
89 stash_msg=$(printf 'On %s: %s' "$branch" "$stash_msg")
91 w_commit=$(printf '%s\n' "$stash_msg" |
92 git commit-tree $w_tree -p $b_commit -p $i_commit) ||
93 die "Cannot record working tree state"
116 git update-index -q --refresh
119 say 'No local changes to save'
122 test -f "$GIT_DIR/logs/$ref_stash" ||
123 clear_stash || die "Cannot initialize stash"
125 create_stash "$stash_msg"
127 # Make sure the reflog for stash is kept.
128 : >>"$GIT_DIR/logs/$ref_stash"
130 git update-ref -m "$stash_msg" $ref_stash $w_commit ||
131 die "Cannot save the current status"
132 say Saved working directory and index state "$stash_msg"
134 git reset --hard ${GIT_QUIET:+-q}
136 if test -n "$keep_index" && test -n $i_tree
138 git read-tree --reset -u $i_tree
143 git rev-parse --verify $ref_stash >/dev/null 2>&1
147 have_stash || return 0
148 git log --no-color --pretty=oneline -g "$@" $ref_stash -- |
149 sed -n -e 's/^[.0-9a-f]* refs\///p'
153 flags=$(git rev-parse --no-revs --flags "$@")
159 w_commit=$(git rev-parse --verify --default $ref_stash "$@") &&
160 b_commit=$(git rev-parse --verify "$w_commit^") &&
161 git diff $flags $b_commit $w_commit
185 have_stash || die 'Nothing to apply'
188 # stash records the work tree, and is a merge between the
189 # base commit (first parent) and the index tree (second parent).
190 s=$(git rev-parse --quiet --verify --default $ref_stash "$@") &&
191 w_tree=$(git rev-parse --quiet --verify "$s:") &&
192 b_tree=$(git rev-parse --quiet --verify "$s^1:") &&
193 i_tree=$(git rev-parse --quiet --verify "$s^2:") ||
194 die "$*: no valid stashed state found"
196 git update-index -q --refresh &&
197 git diff-files --quiet --ignore-submodules ||
198 die 'Cannot apply to a dirty working tree, please stage your changes'
200 # current index state
201 c_tree=$(git write-tree) ||
202 die 'Cannot apply a stash in the middle of a merge'
204 unstashed_index_tree=
205 if test -n "$unstash_index" && test "$b_tree" != "$i_tree" &&
206 test "$c_tree" != "$i_tree"
208 git diff-tree --binary $s^2^..$s^2 | git apply --cached
210 die 'Conflicts in index. Try without --index.'
211 unstashed_index_tree=$(git write-tree) ||
212 die 'Could not save index tree'
217 GITHEAD_$w_tree='Stashed changes' &&
218 GITHEAD_$c_tree='Updated upstream' &&
219 GITHEAD_$b_tree='Version stash was based on' &&
220 export GITHEAD_$w_tree GITHEAD_$c_tree GITHEAD_$b_tree
223 if test -n "$GIT_QUIET"
225 export GIT_MERGE_VERBOSITY=0
227 if git merge-recursive $b_tree -- $c_tree $w_tree
230 if test -n "$unstashed_index_tree"
232 git read-tree "$unstashed_index_tree"
235 git diff-index --cached --name-only --diff-filter=A $c_tree >"$a" &&
236 git read-tree --reset $c_tree &&
237 git update-index --add --stdin <"$a" ||
238 die "Cannot unstage modified files"
242 if test -n "$GIT_QUIET"
244 squelch='>/dev/null 2>&1'
246 eval "git status $squelch" || :
248 # Merge conflict; keep the exit status from merge-recursive
250 if test -n "$unstash_index"
252 echo >&2 'Index was not unstashed.'
259 have_stash || die 'No stash entries to drop'
276 set x "$ref_stash@{0}"
279 # Verify supplied argument looks like a stash entry
280 s=$(git rev-parse --verify "$@") &&
281 git rev-parse --verify "$s:" > /dev/null 2>&1 &&
282 git rev-parse --verify "$s^1:" > /dev/null 2>&1 &&
283 git rev-parse --verify "$s^2:" > /dev/null 2>&1 ||
284 die "$*: not a valid stashed state"
286 git reflog delete --updateref --rewrite "$@" &&
287 say "Dropped $* ($s)" || die "$*: Could not drop stash entry"
289 # clear_stash if we just dropped the last stash entry
290 git rev-parse --verify "$ref_stash@{0}" > /dev/null 2>&1 || clear_stash
294 have_stash || die 'Nothing to apply'
296 test -n "$1" || die 'No branch name specified'
301 set x "$ref_stash@{0}"
305 git checkout -b $branch $stash^ &&
306 apply_stash --index $stash &&
338 if test $# -gt 0 && test "$1" = create
342 create_stash "$*" && echo "$w_commit"
352 test -z "$unstash_index" || shift
364 say '(To restore them type "git stash apply")'